/*================================================================================================================*/
// ********************************** THESE ARE THE INFORMATIONS OF THE MAP: ************************************ //
/*================================================================================================================*/
// THE EAST COAST:
// CREATED BY DANY:
// APRIL 2007:
/*================================================================================================================*/
// ********************************** MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: *********************************** //
/*================================================================================================================*/
include "mercenaries.xs";
void main(void)
{
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
		
		if (rmAllocateSubCivs(3) == true)
   {
		subCiv0=rmGetCivID("Cherokee");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Cherokee");

		subCiv1=rmGetCivID("Cherokee");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Cherokee"); 

		subCiv2=rmGetCivID("Cherokee");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Cherokee");
	}	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************* PICKS THE MAP SIZE: ********************************************** //
/*================================================================================================================*/	
	    
		int playerTiles=17500;
        		
	    int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(530, 530);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ******************************************* SET THE MAP PARAMETERS: ****************************************** //
/*================================================================================================================*/

	    // SET MAP ELEVATION PARAMETERS:
	    rmSetMapElevationParameters(cElevTurbulence, 0.4, 6, 0.7, 5.0);  // LIKE TEXAS FOR THE MOMENT:
	    
		// SET MAP ELEVATION HEIGHT BLEND:
		rmSetMapElevationHeightBlend(1.0);

	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(2.0); // FROM NEW ENGLAND:

	    // SET SEA MAP TYPE:
	    rmSetSeaType("new england coast"); // FROM NEW ENGLAND:
	    
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);
	    
		// TERRAIN INITIALIZATION:
		rmTerrainInitialize("water");
	    
		// SET MAP TYPE:
		rmSetMapType("newEngland"); // FROM NEW ENGLAND:
	    rmSetMapType("water");
	    rmSetMapType("grass");
		
		// SET WORLD CIRCLE CONSTRAINT:
		rmSetWorldCircleConstraint(true);
	    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2.0);
        
		// SET LIGHTING:
		rmSetLightingSet("new england"); // FROM NEW ENGLAND:
	    
		// CHOOSE MERCS:
		chooseMercs();
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int classPlayer=rmDefineClass("player");
		rmDefineClass("classCliff");
		rmDefineClass("startingUnit");
		int classbigContinent=rmDefineClass("big continent");
		rmDefineClass("classHillArea");
		rmDefineClass("nuggets");
		rmDefineClass("SocketClass");
		rmDefineClass("natives");
		rmDefineClass("classForest");
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ****************************************** DEFINE THE CONSTRAINTS: ******************************************* //
// ************************** THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // MAP EDGE CONSTRAINTSW:
	    //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(28), rmZTilesToFraction(28), 1.0-rmXTilesToFraction(28), 1.0-rmZTilesToFraction(28), 0.01);
	    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.40), rmDegreesToRadians(0), rmDegreesToRadians(360));
	    
	    // PLAYER CONSTRAINTS:
	    int playerConstraint=rmCreateClassDistanceConstraint("player vs. player", classPlayer, 30.0);
		
		// BONUS AREA CONSTRAINT:
	    int bigContinentConstraint=rmCreateClassDistanceConstraint("avoid bonus island", classbigContinent, 20.0);
		
		// Cardinal Directions
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));
				
		// CLIFF AVOIDANCE:
		int cliffConstraint=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 20.0);
	    int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 10.0);
	    int shortAvoidCliff=rmCreateClassDistanceConstraint("short stuff vs. cliff", rmClassID("classCliff"), 8.0);
		
		// FOREST AVOIDANCE:
	    int forestConstraint=rmCreateClassDistanceConstraint("forest vs. forest", rmClassID("classForest"), 20.0);
		
		// AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 10.0);
        int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close impassable land", "Land", false, 2.0);
	   			
		// GOLD MINES AVOIDANCE:
		int avoidGold=rmCreateTypeDistanceConstraint("stuff avoid gold", "minegold", 10.0);
		int avoidCloseGold=rmCreateTypeDistanceConstraint("close avoid gold", "minegold", 2.0);
		
		// EAGLES NEST AVOIDANCE:
		int avoidEagles=rmCreateTypeDistanceConstraint("stuff avoid eaglesnest", "EaglesNest", 10.0);
		int avoidCloseEagles=rmCreateTypeDistanceConstraint("close avoid eaglesnest", "EaglesNest", 2.0);
				
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("fruits avoids fruits", "berrybush", 10.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoids fruits", "berrybush", 2.0);
		
		// NUGGET AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 10.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 2.0);
		
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 12.0);
        int avoidCloseNatives=rmCreateClassDistanceConstraint("close avoids natives", rmClassID("natives"), 2.0);
		
		// DEER AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("stuff avoids deer", "deer", 10.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "deer", 2.0);
		
		// COW AVOIDANCE:
		int avoidCow=rmCreateTypeDistanceConstraint("stuff avoids cow", "cow", 10.0);
		int avoidCloseCow=rmCreateTypeDistanceConstraint("close avoids cow", "cow", 2.0);
		
		// DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 6.0);
		
		// UNIT AVOIDANCE:
        int avoidStartingUnits=rmCreateClassDistanceConstraint("objects avoid starting units", rmClassID("startingUnit"), 10.0);
        int avoidStartingUnitsSmall=rmCreateClassDistanceConstraint("objects avoid starting units small", rmClassID("startingUnit"), 3.0);

		// FLAG AVOIDANCE:
		int flagVsFlag = rmCreateTypeDistanceConstraint("flag avoid same", "HomeCityWaterSpawnFlag", 20);
        int flagLand = rmCreateTerrainDistanceConstraint("flag vs land", "land", true, 15.0);
        int flagEdgeConstraint = rmCreatePieConstraint("flags stay near edge of map", 0.5, 0.5, rmGetMapXSize()-20, rmGetMapXSize()-10, 0, 0, 0);
        int flagConstraint=rmCreateHCGPConstraint("flags avoid same", 20.0);
		
		// SEA FOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 8.0);
	    int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "HumpbackWhale", 50.0);
	    int whaleLand = rmCreateTerrainDistanceConstraint("whale land", "land", true, 25.0);
		
		// VP AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 4.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 2.0);
      
	    // SOCKET AVOIDANCE:
	    int avoidSocket=rmCreateClassDistanceConstraint("socket avoidance", rmClassID("SocketClass"), 4.0);
	    int avoidCloseSocket=rmCreateClassDistanceConstraint("close socket avoidance", rmClassID("SocketClass"), 2.0);
	    		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// **************************************** DEFINE THE AREAS OF THE MAP: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //
/*================================================================================================================*/
        if(cNumberNonGaiaPlayers == 2)
	
	{  
		rmSetPlacementTeam(0);
		rmPlacePlayer(1,0.8,0.7);
		rmSetPlacementTeam(1);
		rmPlacePlayer(2,0.15,0.40);
	}  
		else
    {		
		//rmSetPlacementTeam(0);
		//rmPlacePlayer(1,0.8,0.8);
		//rmPlacePlayer(2,0.8,0.2);
		//rmSetPlacementTeam(1);
		//rmPlacePlayer(3,0.2,0.2);
        //rmPlacePlayer(4,0.2,0.8);
	}   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ******************************************** SET UP PLAYER AREAS: ******************************************** //
/*================================================================================================================*/
        
		float playerFraction=rmAreaTilesToFraction(100);
        
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
        
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
      
	    // SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
      
	    // ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
      
	    // SET AREA MIN AND MAX BLOBS:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
      
	    // ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint); 
        
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
        
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
        
		// SET AREA BASE HEIGHT:
		// rmSetAreaBaseHeight(id, 8.0);
        
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }

        // BUILD THE AREAS:
        rmBuildAllAreas();
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE BIG CONTINENT: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int bigContinentID=rmCreateArea("big continent");
        rmSetAreaSize(bigContinentID, 0.55, 0.55);		// 0.65, 0.65
        rmSetAreaWarnFailure(bigContinentID, false);
        rmAddAreaToClass(bigContinentID, classbigContinent);
        rmSetAreaSmoothDistance(bigContinentID, 50);
	    rmSetAreaMix(bigContinentID, "newengland_grass");
        rmSetAreaElevationType(bigContinentID, cElevTurbulence);
        rmSetAreaElevationVariation(bigContinentID, 2.5);
        rmSetAreaBaseHeight(bigContinentID, 4.0);
        rmSetAreaElevationMinFrequency(bigContinentID, 0.09);
        rmSetAreaElevationOctaves(bigContinentID, 3);
        rmSetAreaElevationPersistence(bigContinentID, 0.2);      
	    rmSetAreaCoherence(bigContinentID, 0.80);
	    // rmSetAreaLocation(bigContinentID, 0.70, 0.45);
		   rmSetAreaLocation(bigContinentID, 0.45, 0.70);
        rmSetAreaEdgeFilling(bigContinentID, 5);
	    rmSetAreaObeyWorldCircleConstraint(bigContinentID, false);
	    rmBuildArea(bigContinentID);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.41);
/*================================================================================================================*/
// ********************* BUILD UP SMALL CONTINENT SPURS CALLED "SMALL CONTINENT SPUR 1 & 2" ********************* //
/*================================================================================================================*/

        // DEFINE AND PLACE THE SMALL CONTINENT SPUR 1:
		int smallContinent1ID=rmCreateArea("small continent spur 1");
        rmSetAreaSize(smallContinent1ID, 0.2, 0.2);
        rmSetAreaWarnFailure(smallContinent1ID, false);
        rmAddAreaToClass(smallContinent1ID, classbigContinent);
		rmSetAreaSmoothDistance(smallContinent1ID, 50);
	    // rmSetAreaMix(smallContinent1ID, "california_grass");
	       rmSetAreaMix(smallContinent1ID, "newengland_grass");
		   //rmSetAreaMix(smallContinent1ID, "rockies_grass");
        rmSetAreaElevationType(smallContinent1ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallContinent1ID, 2.5);
        rmSetAreaBaseHeight(smallContinent1ID, 4.0);
        rmSetAreaElevationMinFrequency(smallContinent1ID, 0.09);
        rmSetAreaElevationOctaves(smallContinent1ID, 3);
        rmSetAreaElevationPersistence(smallContinent1ID, 0.2);      
	    rmSetAreaCoherence(smallContinent1ID, 0.80);
	    rmSetAreaLocation(smallContinent1ID, 0.64, 0.65);
        rmSetAreaEdgeFilling(smallContinent1ID, 5);
        rmSetAreaObeyWorldCircleConstraint(smallContinent1ID, false);
	    rmBuildArea(smallContinent1ID);

/*----------------------------------------------------------------------------------------------------------------*/		
		
        // DEFINE AND PLACE THE SMALL CONTINENT SPUR 2:
		int smallContinent2ID=rmCreateArea("small continent spur 2");
        rmSetAreaSize(smallContinent2ID, 0.2, 0.2);
        rmSetAreaWarnFailure(smallContinent2ID, false);
        rmAddAreaToClass(smallContinent2ID, classbigContinent);
		rmSetAreaSmoothDistance(smallContinent2ID, 50);
	    // rmSetAreaMix(smallContinent2ID, "california_grass");
	       rmSetAreaMix(smallContinent2ID, "newengland_grass");
		   //rmSetAreaMix(smallContinent2ID, "rockies_grass");
        rmSetAreaElevationType(smallContinent2ID, cElevTurbulence);
        rmSetAreaElevationVariation(smallContinent2ID, 2.5);
        rmSetAreaBaseHeight(smallContinent2ID, 4.0);
        rmSetAreaElevationMinFrequency(smallContinent2ID, 0.09);
        rmSetAreaElevationOctaves(smallContinent2ID, 3);
        rmSetAreaElevationPersistence(smallContinent2ID, 0.2);      
	    rmSetAreaCoherence(smallContinent2ID, 0.80);
	    // rmSetAreaLocation(smallContinent2ID, 0.45, 0.25);
		   rmSetAreaLocation(smallContinent2ID, 0.25, 0.45);
        rmSetAreaEdgeFilling(smallContinent2ID, 5);
        rmSetAreaObeyWorldCircleConstraint(smallContinent2ID, false);
	    rmBuildArea(smallContinent2ID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/

	    // TEXT: 
	    // PLACEMENT ORDER:
        // TRADE ROUTE -> RIVER (NONE ON THIS MAP) -> NATIVES -> SECRETS -> CLIFFS -> NUGGETS:

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE TRADE ROUTES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
      
      // DEFINE AND PLACE THE TRADE ROUTE NUMBER 1:
	  
	  int tradeRouteID = rmCreateTradeRoute();
      
	  int socketID=rmCreateObjectDef("sockets to dock Trade Posts south");
      rmSetObjectDefTradeRouteID(socketID, tradeRouteID);
      rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
      rmSetObjectDefAllowOverlap(socketID, true);
      rmAddObjectDefToClass(socketID, rmClassID("SocketClass"));
      rmSetObjectDefMinDistance(socketID, 0.0);
      rmSetObjectDefMaxDistance(socketID, 12.0);

	  rmAddTradeRouteWaypoint(tradeRouteID, 0.10, 0.55);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.20, 0.80);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.40, 0.90);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.60, 0.90);
	  rmAddTradeRouteWaypoint(tradeRouteID, 0.75, 0.85);
	  	  
      bool placedTradeRoute = rmBuildTradeRoute(tradeRouteID, "dirt");
      if(placedTradeRoute == false)
      rmEchoError("Failed to place trade route"); 
	  
/*================================================================================================================*/
  
	  // ADD THE SOCKETS ALONG THE TRADE ROUTE NUMBER 1:
      vector socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 0.50);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
      socketLoc = rmGetTradeRouteWayPoint(tradeRouteID, 1.0);
      rmPlaceObjectDefAtPoint(socketID, 0, socketLoc);
	  
	  rmClearClosestPointConstraints();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ****************************** DEFINE THE STARTING UNITS AND STARTING TCID: ********************************** //
/*================================================================================================================*/     
	
	    // CLEAR CLOSEST POINT CONSTRAINTS:
		rmClearClosestPointConstraints(); // CLEAR FOR WATERFLAG PLACEMENT: 
		
		// DEFINE THE STARTING UNITS:
	    int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
	    rmSetObjectDefMinDistance(startingUnits, 7.0);
	    rmSetObjectDefMaxDistance(startingUnits, 12.0);

	    // DEFINE THE STARTING TCID:
		int startingTCID = rmCreateObjectDef("startingTC");
	    if ( rmGetNomadStart())
	{
		rmAddObjectDefItem(startingTCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(startingTCID, "TownCenter", 1, 0.0);
	}
	    rmAddObjectDefToClass(startingTCID, rmClassID("startingUnit"));
	    rmSetObjectDefMinDistance(startingTCID, 0.0);
	    rmSetObjectDefMaxDistance(startingTCID, 0.0);
	    //rmAddObjectDefConstraint(startingTCID, avoidTradeRouteSmall);

	    //rmAddObjectDefConstraint(startingTCID, avoidTradeRoute);
		
/*================================================================================================================*/
// ************************************** DEFINE THE STARTING RESOURCES: **************************************** //
/*================================================================================================================*/
	    
		// DEFINE THE STARTING TREES:
		int StartAreaTreeID=rmCreateObjectDef("starting trees");
	    rmAddObjectDefItem(StartAreaTreeID, "TreeNewEngland", 1, 0.0);
	    rmSetObjectDefMinDistance(StartAreaTreeID, 12.0);
	    rmSetObjectDefMaxDistance(StartAreaTreeID, 18.0);
	    rmAddObjectDefConstraint(StartAreaTreeID, avoidStartingUnitsSmall);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseGold);
		rmAddObjectDefConstraint(StartAreaTreeID, avoidCloseFruits);

	    // DEFINE THE STARTING BISON:
		int StartDeerID=rmCreateObjectDef("Starting Deer");
	    rmAddObjectDefItem(StartDeerID, "deer", 4, 4.0);
	    rmSetObjectDefMinDistance(StartDeerID, 10.0);
	    rmSetObjectDefMaxDistance(StartDeerID, 12.0);
	    rmSetObjectDefCreateHerd(StartDeerID, true);
	    rmAddObjectDefConstraint(StartDeerID, avoidStartingUnitsSmall);
		
		// DEFINE THE STARTING BERRYBUSH:
		int StartBerriesID=rmCreateObjectDef("starting berries");
	    rmAddObjectDefItem(StartBerriesID, "berrybush", 4, 4.0);
	    rmSetObjectDefMinDistance(StartBerriesID, 0.0);
	    rmSetObjectDefMaxDistance(StartBerriesID, 0.0);
	    rmAddObjectDefConstraint(StartBerriesID, avoidFruits);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.80, 0.75);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.80, 0.65);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.15, 0.45);
		rmPlaceObjectDefAtLoc(StartBerriesID, 0, 0.15, 0.35);
		
		// DEFINE THE STARTING GOLDMINES:
		int StartGoldID=rmCreateObjectDef("starting goldmines");
	    rmAddObjectDefItem(StartGoldID, "minegold", 1, 0.0);
	    rmSetObjectDefMinDistance(StartGoldID, 0.0);
	    rmSetObjectDefMaxDistance(StartGoldID, 0.0);
	    rmAddObjectDefConstraint(StartGoldID, avoidGold);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.75, 0.70);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.85, 0.70);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.10, 0.40);
		rmPlaceObjectDefAtLoc(StartGoldID, 0, 0.20, 0.40);
		
	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID=rmCreateObjectDef("player nugget");
	    rmAddObjectDefItem(playerNuggetID, "nugget", 1, 0.0);
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("nuggets"));
	    rmAddObjectDefToClass(playerNuggetID, rmClassID("startingUnit"));
        rmSetObjectDefMinDistance(playerNuggetID, 28.0);
        rmSetObjectDefMaxDistance(playerNuggetID, 35.0);
	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
	    rmAddObjectDefConstraint(playerNuggetID, avoidCloseFruits);
	    rmAddObjectDefConstraint(playerNuggetID, avoidCloseGold);
	    //rmAddObjectDefConstraint(playerNuggetID, circleConstraint);
	    //rmAddObjectDefConstraint(playerNuggetID, avoidImportantItem);
	
/*	    // VARIABLE FOR THE PLAYER GOLD:
		int silverType = -1;
	    int playerGoldID = -1;
*/	

/*----------------------------------------------------------------------------------------------------------------*/

        // DEFINE THE WATER FLAG:
		int waterFlagID=rmCreateObjectDef("HC water flag "+i);
        rmAddObjectDefItem(waterFlagID, "HomeCityWaterSpawnFlag", 1, 0.0);
        rmAddClosestPointConstraint(flagEdgeConstraint);
        rmAddClosestPointConstraint(flagVsFlag);
        rmAddClosestPointConstraint(flagLand);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ********************** PLACE THE STARTING TCID AND STARTING UNITS AND STARTING RESOURCES: ******************** //	
/*================================================================================================================*/

 	    for(i=1; <cNumberPlayers)
	{
		// PLACE THE STARTING TCID:
		rmPlaceObjectDefAtLoc(startingTCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
	    vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(startingTCID, i));
	    vector closestPoint = rmFindClosestPointVector(TCLoc, rmXFractionToMeters(1.0));
						
		// PLACE THE STARTING UNITS:
		rmPlaceObjectDefAtLoc(startingUnits, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
				
/*		
        // DEFINE THE PLAYER GOLD:
		// EVERYONE GETS TWO ORE OBJECTDEFS, ONE PRETTY CLOSE, THE OTHER A LITTLE FURTHER AWAY:
		silverType = rmRandInt(1,10);
		playerGoldID = rmCreateObjectDef("player silver closer "+i);
		rmAddObjectDefItem(playerGoldID, "mine", 1, 0.0);
		// rmAddObjectDefToClass(playerGoldID, rmClassID("importantItem"));
		rmAddObjectDefConstraint(playerGoldID, avoidTradeRoute);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingCoin);
		rmAddObjectDefConstraint(playerGoldID, avoidStartingUnitsSmall);
		rmSetObjectDefMinDistance(playerGoldID, 15.0);
		rmSetObjectDefMaxDistance(playerGoldID, 20.0);
		
		// PLACE THE TWO GOLD MINES:
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerGoldID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));*/

		// PLACING STARTING TREES:
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(StartAreaTreeID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE STARTING BISONS:
		rmPlaceObjectDefAtLoc(StartDeerID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));

		// PLACE THE PLAYER NUGGET:
		rmSetNuggetDifficulty(1, 1);
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));


        // PLACE THE WATER FLAG:
		rmPlaceObjectDefAtLoc(waterFlagID, i, rmXMetersToFraction(xsVectorGetX(closestPoint)), rmZMetersToFraction(xsVectorGetZ(closestPoint)));
		
		
	}
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// *********************************** DEFINE AND PLACE THE NATIVE AMERICANS ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*================================================================================================================*/

        if (subCiv0 == rmGetCivID("cherokee"))
	{  
		int cherokee1VillageID = -1;
		cherokee1VillageID = rmCreateGrouping("cherokee village 1", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee1VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee1VillageID, 0.0);
		rmAddGroupingToClass(cherokee1VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee1VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee1VillageID, 0, 0.55, 0.75);
	}  
	
/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv1 == rmGetCivID("cherokee"))
	{  
		int cherokee2VillageID = -1;
		cherokee2VillageID = rmCreateGrouping("cherokee village 2", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee2VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee2VillageID, 0.0);
		rmAddGroupingToClass(cherokee2VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee2VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee2VillageID, 0, 0.30, 0.50);
	}  

/*----------------------------------------------------------------------------------------------------------------*/

        if (subCiv2 == rmGetCivID("cherokee"))
	{  
		int cherokee3VillageID = -1;
		cherokee3VillageID = rmCreateGrouping("cherokee village 3", "native cherokee village 1");
		rmSetGroupingMinDistance(cherokee3VillageID, 0.0);
		rmSetGroupingMaxDistance(cherokee3VillageID, 0.0);
		rmAddGroupingToClass(cherokee3VillageID, rmClassID("natives"));
		rmAddGroupingConstraint(cherokee3VillageID, avoidNatives);
		rmPlaceGroupingAtLoc(cherokee3VillageID, 0, 0.60, 0.50);
	}  	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE CLIFFS: ***************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        // int numTries=cNumberNonGaiaPlayers+2;
		   int numTries=cNumberNonGaiaPlayers*0.5;
   
        for(i=0; <numTries)
   {
        // int cliffID=rmCreateArea("cliff"+i);
		   int cliffID=rmCreateArea("cliff");
        rmSetAreaSize(cliffID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
        rmSetAreaWarnFailure(cliffID, false);
	    rmSetAreaCliffType(cliffID, "New England");
	    rmSetAreaCliffEdge(cliffID, 1, 0.6, 0.8, 1.0, 0);
        rmSetAreaCliffPainting(cliffID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliffID, 5, 2.0, 0.5);
        rmSetAreaHeightBlend(cliffID, 1);
        rmAddAreaToClass(cliffID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliffID, cliffConstraint);
	    rmSetAreaMinBlobs(cliffID, 1);
        rmSetAreaMaxBlobs(cliffID, 1);
        rmSetAreaMinBlobDistance(cliffID, 1);
        rmSetAreaMaxBlobDistance(cliffID, 1);
        rmSetAreaSmoothDistance(cliffID, 10);
        rmSetAreaCoherence(cliffID, 0.95);
		rmSetAreaLocation(cliffID, 0.55, 0.75);
        rmBuildArea(cliffID);
   } 
   
/*----------------------------------------------------------------------------------------------------------------*/

        for(i=0; <numTries)
   {
        // int cliff2ID=rmCreateArea("cliff 2"+i);
		   int cliff2ID=rmCreateArea("cliff 2");
        rmSetAreaSize(cliff2ID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
        rmSetAreaWarnFailure(cliff2ID, false);
	    rmSetAreaCliffType(cliff2ID, "New England");
	    rmSetAreaCliffEdge(cliff2ID, 1, 0.6, 0.8, 1.0, 0);
        rmSetAreaCliffPainting(cliff2ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff2ID, 5, 2.0, 0.5);
        rmSetAreaHeightBlend(cliff2ID, 1);
        rmAddAreaToClass(cliff2ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff2ID, cliffConstraint);
	    rmSetAreaMinBlobs(cliff2ID, 1);
        rmSetAreaMaxBlobs(cliff2ID, 1);
        rmSetAreaMinBlobDistance(cliff2ID, 1);
        rmSetAreaMaxBlobDistance(cliff2ID, 1);
        rmSetAreaSmoothDistance(cliff2ID, 10);
        rmSetAreaCoherence(cliff2ID, 0.95);
		rmSetAreaLocation(cliff2ID, 0.30, 0.50);
        rmBuildArea(cliff2ID);
   }    
   
/*----------------------------------------------------------------------------------------------------------------*/

        for(i=0; <numTries)
   {
        // int cliff2ID=rmCreateArea("cliff 2"+i);
		   int cliff3ID=rmCreateArea("cliff 3");
        rmSetAreaSize(cliff3ID, rmAreaTilesToFraction(1000), rmAreaTilesToFraction(1000));
        rmSetAreaWarnFailure(cliff3ID, false);
	    rmSetAreaCliffType(cliff3ID, "New England");
	    rmSetAreaCliffEdge(cliff3ID, 1, 0.6, 0.8, 1.0, 0);
        rmSetAreaCliffPainting(cliff3ID, false, true, true, 1.5, true);
        rmSetAreaCliffHeight(cliff3ID, 5, 2.0, 0.5);
        rmSetAreaHeightBlend(cliff3ID, 1);
        rmAddAreaToClass(cliff3ID, rmClassID("classCliff")); 
        rmAddAreaConstraint(cliff3ID, cliffConstraint);
	    rmSetAreaMinBlobs(cliff3ID, 1);
        rmSetAreaMaxBlobs(cliff3ID, 1);
        rmSetAreaMinBlobDistance(cliff3ID, 1);
        rmSetAreaMaxBlobDistance(cliff3ID, 1);
        rmSetAreaSmoothDistance(cliff3ID, 10);
        rmSetAreaCoherence(cliff3ID, 0.95);
		rmSetAreaLocation(cliff3ID, 0.6, 0.5);
        rmBuildArea(cliff3ID);
   }  
/*================================================================================================================*/
// *************************** DEFINE AND PLACE THE POND TO THE CENTER OF THE MAP: ****************************** //
/*================================================================================================================*/

        // DEFINE THE CENTRAL POND:
	    int pondClass=rmDefineClass("pond");
        int pondConstraint=rmCreateClassDistanceConstraint("things avoid the pond", rmClassID("pond"), 20.0);
        int smallPondID=rmCreateArea("small pond");
	    
	
		rmSetAreaSize(smallPondID, rmAreaTilesToFraction(1500), rmAreaTilesToFraction(1500));
		// rmSetAreaWaterType(smallPondID, "great plains pond");
		   rmSetAreaWaterType(smallPondID, "new england lake");
		rmSetAreaBaseHeight(smallPondID, 4);
		rmSetAreaMinBlobs(smallPondID, 1);
		rmSetAreaMaxBlobs(smallPondID, 1);
		rmSetAreaMinBlobDistance(smallPondID, 1.0);
		rmSetAreaMaxBlobDistance(smallPondID, 1.0);
		rmAddAreaToClass(smallPondID, pondClass);
		rmSetAreaCoherence(smallPondID, 0.95);
		rmSetAreaSmoothDistance(smallPondID, 5);
		//rmAddAreaConstraint(smallPondID, playerConstraint);
		//rmAddAreaConstraint(smallPondID, avoidTradeRoute);
		//rmAddAreaConstraint(smallPondID, avoidImportantItem);
		rmSetAreaWarnFailure(smallPondID, false);
		rmSetAreaLocation(smallPondID, 0.375, 0.675); 
		rmBuildArea(smallPondID);   

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 1:
		int nugget1ID= rmCreateObjectDef("nugget 1"); 
	    rmAddObjectDefItem(nugget1ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget1ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget1ID, 0.0);
	    rmAddObjectDefConstraint(nugget1ID, avoidNugget);
		
		rmSetNuggetDifficulty(1, 3);
	    rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.125, 0.775);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.325, 0.925);
		rmPlaceObjectDefAtLoc(nugget1ID, 0, 0.55, 0.95);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 2:
		int nugget2ID= rmCreateObjectDef("nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, 0.0);
	    rmAddObjectDefConstraint(nugget2ID, avoidNugget);
		
		rmSetNuggetDifficulty(1, 3);
	    rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.40, 0.45);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.50, 0.60);
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.625, 0.65);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NUGGETS NUMBER 3:
		int nugget3ID= rmCreateObjectDef("nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, 0.0);
	    rmAddObjectDefConstraint(nugget3ID, avoidNugget);
		
		rmSetNuggetDifficulty(1, 3);
	    rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.75, 0.55);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.525, 0.375);
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.30, 0.30);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE WHALE: ******************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    if(rmRandFloat(0,1) < 0.5)
   {
		int whaleID=rmCreateObjectDef("whale");
		rmAddObjectDefItem(whaleID, "HumpbackWhale", 1, 0.0);
		rmSetObjectDefMinDistance(whaleID, 0.0);
		rmSetObjectDefMaxDistance(whaleID, rmXFractionToMeters(0.5));
		rmAddObjectDefConstraint(whaleID, whaleVsWhaleID);
		rmAddObjectDefConstraint(whaleID, whaleLand);
		rmPlaceObjectDefAtLoc(whaleID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
   }

/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE FISHES: ***************************************** //   
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ******************************* PLACE RESOURCES THAT WE WANT FORESTS TO AVOID: ******************************* //
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE GOLD WEST: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

		// THE GOLD MINE NUMBER 1:
		int gold1ID = rmCreateObjectDef("gold 1");
		rmAddObjectDefItem(gold1ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold1ID, 0.0);
		rmSetObjectDefMaxDistance(gold1ID, 0.0);
		rmAddObjectDefConstraint(gold1ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.05, 0.65);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.225, 0.875);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.45, 0.95);
		rmPlaceObjectDefAtLoc(gold1ID, 0, 0.65, 0.95);

/*----------------------------------------------------------------------------------------------------------------*/
		
		// THE GOLD MINE NUMBER 2:
		int gold2ID = rmCreateObjectDef("gold 2");
		rmAddObjectDefItem(gold2ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold2ID, 0.0);
		rmSetObjectDefMaxDistance(gold2ID, 0.0);
		rmAddObjectDefConstraint(gold2ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.575, 0.625);
		rmPlaceObjectDefAtLoc(gold2ID, 0, 0.45, 0.50);
		//rmPlaceObjectDefAtLoc(gold2ID, 0, 0.45, 0.95);
		//rmPlaceObjectDefAtLoc(gold2ID, 0, 0.65, 0.95);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE GOLD MINE NUMBER 3:
		int gold3ID = rmCreateObjectDef("gold 3");
		rmAddObjectDefItem(gold3ID, "minegold", 1, 0.0);
		rmSetObjectDefMinDistance(gold3ID, 0.0);
		rmSetObjectDefMaxDistance(gold3ID, 0.0);
		rmAddObjectDefConstraint(gold3ID, avoidGold);
				
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.70, 0.45);
		rmPlaceObjectDefAtLoc(gold3ID, 0, 0.40, 0.35);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.45, 0.95);
		//rmPlaceObjectDefAtLoc(gold3ID, 0, 0.65, 0.95);
		
/*================================================================================================================*/		
// **************************************** DEFINE AND PLACE THE BISONS: **************************************** //
/*================================================================================================================*/ 
	   
        int deer1ID=rmCreateObjectDef("The Deer Herds 1");
        rmAddObjectDefItem(deer1ID, "deer", rmRandInt(7,12), 5.0);
        rmSetObjectDefMinDistance(deer1ID, 0.0);
        rmSetObjectDefMaxDistance(deer1ID, 0.0);
	    rmAddObjectDefConstraint(deer1ID, avoidDeer);
		rmSetObjectDefCreateHerd(deer1ID, true);
	    
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.20, 0.60);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.50, 0.45);
		
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.45, 0.80);
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.65, 0.80);

        rmPlaceObjectDefAtLoc(deer1ID, 0, 0.05, 0.45);
        rmPlaceObjectDefAtLoc(deer1ID, 0, 0.35, 0.35);

        rmPlaceObjectDefAtLoc(deer1ID, 0, 0.7, 0.6);

/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE COWS: ****************************************** //		
/*================================================================================================================*/
	
        int cow1ID=rmCreateObjectDef("The Cows 1");
        rmAddObjectDefItem(cow1ID, "cow", rmRandInt(4,7), 4.0);
        rmSetObjectDefMinDistance(cow1ID, 0.0);
        rmSetObjectDefMaxDistance(cow1ID, 0.0);
	    rmAddObjectDefConstraint(cow1ID, avoidCow);
		rmSetObjectDefCreateHerd(cow1ID, true);
	    
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.25, 0.75);
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.55, 0.85);
        
		rmPlaceObjectDefAtLoc(cow1ID, 0, 0.20, 0.50);
        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.725, 0.50);

        rmPlaceObjectDefAtLoc(cow1ID, 0, 0.45, 0.35);

/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //
/*================================================================================================================*/
        
		int berries1ID = rmCreateObjectDef("The Berries 1");
		rmAddObjectDefItem(berries1ID, "berrybush", rmRandInt(3,5), 4.0);
		rmSetObjectDefMinDistance(berries1ID, 0.0);
		rmSetObjectDefMaxDistance(berries1ID, 0.0);
		rmAddObjectDefConstraint(berries1ID, avoidFruits);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.10, 0.70);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.25, 0.90);
		
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.60, 0.95);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.60, 0.35);

        rmPlaceObjectDefAtLoc(berries1ID, 0, 0.55, 0.60);
		rmPlaceObjectDefAtLoc(berries1ID, 0, 0.425, 0.525);

        rmPlaceObjectDefAtLoc(berries1ID, 0, 0.05, 0.35);
        rmPlaceObjectDefAtLoc(berries1ID, 0, 0.825, 0.825);	
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DECORATIONS: ************************************** //	
/*================================================================================================================*/

        // THE DECORATION NUMBER 1:
		int Eagles1ID = rmCreateObjectDef("Eagles Nest 1");
		rmAddObjectDefItem(Eagles1ID, "EaglesNest", 1, 0.0);
		rmSetObjectDefMinDistance(Eagles1ID, 0.0);
		rmSetObjectDefMaxDistance(Eagles1ID, 0.0);
		rmAddObjectDefConstraint(Eagles1ID, avoidEagles);
				
		rmPlaceObjectDefAtLoc(Eagles1ID, 0, 0.30, 0.80);
		rmPlaceObjectDefAtLoc(Eagles1ID, 0, 0.7, 0.9);
		rmPlaceObjectDefAtLoc(Eagles1ID, 0, 0.675, 0.675);
		rmPlaceObjectDefAtLoc(Eagles1ID, 0, 0.45, 0.40); 
		rmPlaceObjectDefAtLoc(Eagles1ID, 0, 0.30, 0.40);
        rmPlaceObjectDefAtLoc(Eagles1ID, 0, 0.15, 0.525); 		
		
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE FORESTS: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
		
		int forestTreeID = 0;
        numTries=6*cNumberNonGaiaPlayers;
        int failCount=0;
	    
		for (i=0; <numTries)
    {   
        int forest=rmCreateArea("forest pine forest"+i);
        rmSetAreaWarnFailure(forest, false);
        rmSetAreaSize(forest, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
        rmSetAreaForestType(forest, "new england forest");
		rmSetAreaForestDensity(forest, 0.85);
        rmSetAreaForestClumpiness(forest, 0.10);
        rmSetAreaForestUnderbrush(forest, 0.6);
        rmSetAreaMinBlobs(forest, 1);
        rmSetAreaMaxBlobs(forest, 2);
        rmSetAreaMinBlobDistance(forest, 1);
        rmSetAreaMaxBlobDistance(forest, 2);
        rmSetAreaCoherence(forest, 0.25);
        rmSetAreaSmoothDistance(forest, 10);
        rmAddAreaToClass(forest, rmClassID("classForest")); 
        rmAddAreaConstraint(forest, forestConstraint);
        rmAddAreaConstraint(forest, avoidAll);
        //rmAddAreaConstraint(forest, avoidCliff);
        rmAddAreaConstraint(forest, avoidImpassableLand); 
        rmAddAreaConstraint(forest, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest, avoidCloseSocket);
		rmAddAreaConstraint(forest, Northward);
		 
        if(rmBuildArea(forest)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  
	
/*----------------------------------------------------------------------------------------------------------------*/

        for (i=0; <numTries)
    {   
        int forest2=rmCreateArea("forest pine forest 2"+i);
        rmSetAreaWarnFailure(forest2, false);
        rmSetAreaSize(forest2, rmAreaTilesToFraction(150), rmAreaTilesToFraction(150));
        rmSetAreaForestType(forest2, "new england forest");
		rmSetAreaForestDensity(forest2, 0.85);
        rmSetAreaForestClumpiness(forest2, 0.10);
        rmSetAreaForestUnderbrush(forest2, 0.6);
        rmSetAreaMinBlobs(forest2, 1);
        rmSetAreaMaxBlobs(forest2, 2);
        rmSetAreaMinBlobDistance(forest2, 1);
        rmSetAreaMaxBlobDistance(forest2, 2);
        rmSetAreaCoherence(forest2, 0.25);
        rmSetAreaSmoothDistance(forest2, 10);
        rmAddAreaToClass(forest2, rmClassID("classForest")); 
        rmAddAreaConstraint(forest2, forestConstraint);
        rmAddAreaConstraint(forest2, avoidAll);
		rmAddAreaConstraint(forest2, avoidCloseSocket);
        //rmAddAreaConstraint(forest2, avoidCliff);
        rmAddAreaConstraint(forest2, avoidImpassableLand); 
        rmAddAreaConstraint(forest2, avoidCloseTradeRoute);
		rmAddAreaConstraint(forest2, Southward);
		 
        if(rmBuildArea(forest2)==false)
      {
        // Stop trying once we fail 5 times in a row.
        failCount++;
        if(failCount==5)
        break;
      }
        else
        failCount=0; 
    }  	

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/
// ******************************** DEFINE AND PLACE THE DEER AND THE ELK HERDS: ******************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*================================================================================================================*/
}
/*================================================================================================================*/
// *************************************** THIS IS THE END OF THE MAP: ****************************************** // 
/*================================================================================================================*/






































